VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.UserControl ctrlDropDownListView 
   ClientHeight    =   1515
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6990
   ScaleHeight     =   1515
   ScaleWidth      =   6990
   Begin VB.CommandButton cmdDrop 
      Height          =   240
      Left            =   4920
      Picture         =   "ctrlDropDownListView.ctx":0000
      Style           =   1  'Graphical
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   0
      Width           =   240
   End
   Begin MSComctlLib.ListView lstChoice 
      Height          =   330
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   5010
      _ExtentX        =   8837
      _ExtentY        =   582
      View            =   3
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      HideColumnHeaders=   -1  'True
      FullRowSelect   =   -1  'True
      GridLines       =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin MSComctlLib.ListView lstListData 
      Height          =   1140
      Left            =   0
      TabIndex        =   1
      Top             =   310
      Visible         =   0   'False
      Width           =   5010
      _ExtentX        =   8837
      _ExtentY        =   2011
      View            =   3
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      HideColumnHeaders=   -1  'True
      FullRowSelect   =   -1  'True
      GridLines       =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   1
      NumItems        =   0
   End
End
Attribute VB_Name = "ctrlDropDownListView"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long

Private Declare Sub CoCreateGuid Lib "ole32.dll" (ByRef pguid As Any)

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Private Const SWP_ASYNCWINDOWPOS = &H4000
Private Const SWP_DEFERERASE = &H2000
Private Const SWP_FRAMECHANGED = &H20
Private Const SWP_DRAWFRAME = SWP_FRAMECHANGED
Private Const SWP_HIDEWINDOW = &H80
Private Const SWP_NOACTIVATE = &H10
Private Const SWP_NOCOPYBITS = &H100
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOOWNERZORDER = &H200
Private Const SWP_NOREDRAW = &H8
Private Const SWP_NOREPOSITION = SWP_NOOWNERZORDER
Private Const SWP_NOSENDCHANGING = &H400
Private Const SWP_NOSIZE = &H1
Private Const SWP_NOZORDER = &H4
Private Const SWP_SHOWWINDOW = &H40

Private MyID            As String

Public Property Get ID() As String
    If Len(MyID) = 0 Then MyID = CreateGUID
    
    ID = MyID
End Property

Public Property Let ID(ByVal vNewValue As String)

End Property

Private Function CreateGUID() As String
    Dim NewGUID(15) As Byte, K As Long
    
    CoCreateGuid NewGUID(0)
    
    CreateGUID = "{"
    For K = 0 To 15
        CreateGUID = CreateGUID & Right("0" & Hex(NewGUID(K)), 2)
        
        Select Case K
        Case 4, 6, 8, 10
            CreateGUID = CreateGUID & "-"
        End Select
    Next K
    
    CreateGUID = CreateGUID & "}"
End Function

Private Sub cmdDrop_Click()
    If Not lstListData.Visible Then
        SetParent lstListData.hwnd, UserControl.hwnd
       
        lstListData.Visible = True
        Call UserControl_Resize

        UserControl.SetFocus
    Else
        lstListData.Visible = False
        DoEvents
        Call UserControl_Resize
        DoEvents
        
        UserControl.SetFocus
        UserControl.Parent.SetFocus
    End If
End Sub

Private Sub cmdDrop_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    UserControl.SetFocus
End Sub

Private Sub lstChoice_BeforeLabelEdit(Cancel As Integer)
    Cancel = 1
End Sub

Private Sub lstChoice_Click()
    cmdDrop_Click
End Sub

Private Sub lstListData_Click()
    Call ColapseList
End Sub

Private Sub UserControl_LostFocus()
    Call ColapseList
End Sub

Public Sub ColapseList()
    If lstListData.Visible Then
        lstListData.Visible = False
        DoEvents
        Call UserControl_Resize
        UserControl.SetFocus
        UserControl.Parent.SetFocus
    End If
End Sub

Private Sub UserControl_Resize()
    Dim FntSize         As Single
    Dim CtrlRect        As RECT
    
    Set UserControl.Font = lstChoice.Font
    FntSize = UserControl.TextHeight("A")
    
    If lstListData.Visible = False Then
        If UserControl.Height > FntSize + 90 + 30 Then
            UserControl.Height = FntSize + 90 + 30
        End If
    
        cmdDrop.Height = UserControl.ScaleHeight - 90
    Else
        UserControl.Height = lstChoice.Height + lstListData.Height - 80
    End If
    
    GetWindowRect UserControl.hwnd, CtrlRect
    DoEvents
    
    lstChoice.Move 0, 0, UserControl.ScaleWidth, UserControl.ScaleHeight
    lstListData.Move 20, CtrlRect.Top - 50, UserControl.ScaleWidth, 1140
    cmdDrop.Move UserControl.ScaleWidth - cmdDrop.Width - 45, 45
    lstListData.Width = UserControl.Width - 50
End Sub

Private Sub UserControl_Terminate()
    '#
End Sub

Public Property Get Columns() As Long
    Columns = lstChoice.ColumnHeaders.Count
End Property

Public Property Let Columns(ByVal vNewValue As Long)
    Dim K As Long
    
    If lstChoice.ColumnHeaders.Count = 0 Then
        For K = 1 To vNewValue
            lstChoice.ColumnHeaders.Add , , Chr(64 + K)
            lstListData.ColumnHeaders.Add , , Chr(64 + K)
        Next K
    Else
        
    End If
End Property

Public Property Get ListItems() As IListItems
    Set ListItems = lstListData.ListItems
End Property

Public Property Let ListItems(ByVal vNewValue As IListItems)
    '#
End Property

Private Sub lstListData_BeforeLabelEdit(Cancel As Integer)
    Cancel = 1
End Sub

Private Sub lstListData_ItemClick(ByVal Item As MSComctlLib.ListItem)
    Dim K As Long, LI As ListItem
    
    SetParent lstListData.hwnd, 0&
    Call ColapseList
    DoEvents
    
    Do Until lstChoice.ListItems.Count = 0
        lstChoice.ListItems.Remove 1
    Loop
    
    Set LI = lstChoice.ListItems.Add(, , Item.Text)
    For K = 1 To lstChoice.ColumnHeaders.Count - 1
        LI.SubItems(K) = Item.SubItems(K)
    Next K
End Sub

